
#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>

#define MIN "s0000000"

using namespace std;

struct Tree
{
	string name, surname, studKr, pazNr;
	int count;
	double vidurkis;
	Tree *left;
	Tree *right;
	Tree *parent;
};

Tree* lookUp(struct Tree *node, string key, int kiek)
{
	if(node == NULL) {
            return node;
	}
	if (node->vidurkis >= 6.5){
        cout << "Studento, kurio vardas ir pavarde yra: " << node->name << " " << node->surname << " vidurkis yra lygus arba didesnis uz 6.5" << endl;
	}
	if(node->pazNr == key) {
            node->count = kiek+1;
            return node;
	}
	else {
	    if(node->pazNr < key){
            kiek = kiek+1;
            return lookUp(node->right, key, kiek) ;
	    }
	    else {
            kiek = kiek +1;
            return lookUp(node->left, key, kiek);
	    }
	}
}

struct Tree *newTreeNode(string key, string vardas, string pavarde, string stud, double vid)
{
	Tree *node = new Tree;
	node->pazNr = key;
	node->vidurkis = vid;
	node->name = vardas;
	node->surname = pavarde;
	node->studKr = stud;
	node->left = NULL;
	node->right = NULL;
	node->parent = NULL;

	return node;
}

struct Tree* insertTreeNode(struct Tree *node, string key, string vardas, string pavarde, string stud, double vid)
{
	static Tree *p;
	Tree *retNode;

	//if(node != NULL) p = node;

	if(node == NULL)  {
	    retNode = newTreeNode(key, vardas, pavarde, stud, vid);
	    retNode->parent = p;
	    return retNode;
	}
	if(key <= node->pazNr ) {
	    p = node;
	    node->left = insertTreeNode(node->left, key, vardas, pavarde, stud, vid);
	}
	else {
	    p = node;
	    node->right = insertTreeNode(node->right, key, vardas, pavarde, stud, vid);
	}
	return node;
}

void clear(struct Tree *node)
{
	if(node != NULL) {
	    clear(node->left);
	    clear(node->right);
	    delete node;
	}
}

void printTreeInOrder(struct Tree *node)
{
	if(node == NULL) return;

	printTreeInOrder(node->left);
	cout << "Pazymejimo nr: " << node->pazNr << ", Vardas: " << node->name<< ", Pavarde: " << node->surname << ", Studiju kryptis: " <<
        node->studKr << ", Vidurkis: " << node->vidurkis << endl;
	printTreeInOrder(node->right);
}


int main(int argc, char **argv){
	Tree *found;

	Tree *root = newTreeNode("s1111111", "Ferdis", "Ferdinandas", "Informatika", 7.5);
	insertTreeNode(root,"s1111112", "Algis", "Algiskas", "Teise", 5.5);
	insertTreeNode(root,"s1111115", "Tomas", "Tomauskas", "Ekonometrija", 6.5);
	insertTreeNode(root,"s1141111", "Matas", "Matauskas", "Informatika", 9.8);
	insertTreeNode(root,"s1111111", "Agris", "Agrauskas", "Informatika", 8.0);
	insertTreeNode(root,"s3111111", "Tymba", "Timberis", "Daile", 6.5);
	insertTreeNode(root,"s1111781", "Bulve", "Bulvinis", "Informatika", 7.5);
	insertTreeNode(root,"s8115111", "Mantas", "Mantauskas", "Informatika", 4.5);
	insertTreeNode(root,"s1141181", "Kazimieras", "Labanauskas", "Programu sistemos", 6.0);
	insertTreeNode(root,"s1141181", "Kazimieras", "Labanauskas", "Informatika", 3.4);

    cout << "-- Medzio apejimas InOrder tvarka pagal pazymejimo numeri --" << endl;
    printTreeInOrder(root);

    cout << "-- Paieskos testavimas --" << endl;
    cout << "Ieskomas studentas, kurio pazymejimo nr: s1111781" << endl;
	found = lookUp(root,"s1111781",0);
	if(found){
	    cout << "Studentas, kurio pazymejimo nr: " << found->pazNr << " rastas. Jo informacija:"<< found->name << " " << found->surname << " " << found->studKr << " " << found->vidurkis << endl;
	    cout << "Pries tai apeitu elementu kiekis, kartu su rastu elementu yra: " << found->count << endl;
	}
	else
	    cout << "Studentas, kurio pazymejimo nr: s1111781, nerastas\n";

    clear(root);
    return 0;
}
